{% extends 'crud/edit.html' %}
{% block custom_header_includes %}
{#    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>#}
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.0"></script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    {% load static %}
    <script src="{% static 'sb_admin/vendor/jquery/jquery.min.js' %}"></script>
    <script src="{% static 'moment/moment.min.js' %}"></script>
    <script src="https://cdn.jsdelivr.net/npm/lodash@4.13.1/lodash.min.js"></script>
{#<script src="{% static 'custom/jquerymask/jquery.mask.js' %}"></script>#}
{#    <script src="{% static 'custom/jquinputmask/jquery.inputmask.js' %}"></script>#}

{% endblock %}
{% load crispy_forms_tags %}


{% block content %}
    <script type="text/javascript">
        var vueContext = {{ vue_context|safe }}
        axios.defaults.xsrfCookieName = 'csrftoken'
        axios.defaults.xsrfHeaderName = "X-CSRFTOKEN"
        const DATEFORMAT = "DD.MM.YYYY"

    </script>
<div id="app">

    <div class="container-fluid">
        <form method="post" action="{% url 'client_abonement_edit' client_id abon_id %}" enctype="multipart/form-data">
            {% csrf_token %}
            <div class="form_group">
                {{ edit_form.activation|as_crispy_field }}
            </div>
            <div v-show="abonActivation" class="activation-part">

                <div class="form_group">
                    {{ edit_form.activation_date|as_crispy_field }}
                </div>
                <div v-show="isActivationDateError" style="display: block" class="invalid-feedback">
                    [[ activationInput.message ]]
                </div>
                <div class="form_group">
                    {{ edit_form.deactivation_date|as_crispy_field }}

                </div>
            </div>

            <div class="form_group">
                {{ edit_form.current_visits_number|as_crispy_field }}
            </div>
            <div class="form_group">
                {{ edit_form.abonement_number_of_freezing|as_crispy_field }}
            </div>
            <input type="hidden" name="next" value="{{ request.META.HTTP_REFERER }}">
            <button type="submit" :disabled="isDisableBtn" id="update-btn" class="btn btn-success">Обновить</button>
            <button type="button" class="btn btn-danger" onclick="window.location.href = document.referrer">Отменить</button>
        </form>
    </div>
</div>
    <script>
    
        const app = new Vue({
            delimiters: ["[[", "]]"],
            el: '#app',
            data() {
                return {
                    activation: vueContext.activation,
                    activationDate: vueContext.activation_date,
                    deactivationDate: vueContext.deactivation_date,
                    deactivationDateShow: vueContext.deactivation_date,
                    disableButton: false,
                    activationInput: {
                        error: false,
                        message: "",
                    }
                }
            },
            watch: {
                activationDate: function (date) {
                    // TODO: сделать запрос, если 400 то отключить кнопку сохранения и покрасить инпут в красный
                    this.debouncedGetDeactivationDate()


                }
            },

            created: function () {
                this.debouncedGetDeactivationDate = _.debounce(this.getDeactivationDate, 350)
            },
            computed: {
                abonActivation: function(){
                    if (vueContext.activation === false && this.activation){
                        this.activationDate = moment(new Date()).format(DATEFORMAT)
                        vueContext.activation = true
                    }
                    return this.activation
                },

                isDisableBtn: function () {
                    return this.disableButton
                },
                isActivationDateError: function () {
                    console.log("DATE ERROR")
                    return this.activationInput.error
                }

            },
            methods: {
                getDeactivationDate(){
                    var formatDate = this.parseDate(this.activationDate)
                    var correctFormatDate = moment(formatDate).format(DATEFORMAT)

                    axios.get("{% url 'ajax_get_deactivation_date' %}", {
                        params:{
                            sale_id: vueContext.sale_id,
                            activation_date: `${formatDate}`
                        }
                    })
                        .then(response => {
                            this.deactivationDate = moment(response.data).format(DATEFORMAT)
                            this.activationDate = this.parseDate(this.activationDate)
                            this.activationInput.error = false
                            this.disableButton = false
                        })

                        .catch(error => {
                            this.activationInput.message = error.response.data.error
                            this.activationDate = this.parseDate(this.activationDate)
                            this.activationInput.error = true
                            this.disableButton = true

                        })
                },

                parseDate(date){
                    let nonFormatDate = date.split('.').join("")
                    let formatter = new StringMask('00.00.0000')
                    return formatter.apply(nonFormatDate)

                }
            }




        })
    </script>

{% endblock %}

{% block custom_includes %}
    {{ block.super }}
    {% load static %}
    <script src="{% static 'sb_admin/vendor/jquery/jquery.min.js' %}"></script>
    <script src="{% static 'custom/jquerymask/jquery.mask.js' %}"></script>
    <script src="{% static 'custom/string-mask/string-mask.js' %}"></script>
        {{ edit_form.media.css }}
{{ edit_form.media.js }}
{% endblock %}